require 'singleton'
require 'yaml'
require 'iepg'
require 'scheinfo'

class IEPG

  #
  #Dxo#to_scheinfo QƁB
  #
  def to_scheinfo
    dxo = Dxo.instance
    dxo.to_scheinfo(self)
  end

end

#= iEPG\f[^ϊNX
#
# ScheInfoւ̕ϊ\bh񋟂B
#
class Dxo

  include Singleton

  CONFIG_FILE = 'config.yaml'
  REGEXP_HOUR_MINUTES = /(\d\d):(\d\d)/

  #=== RXgN^
  #
  # \IDp̎IuWFNgpӂB
  # erǖAzzpӂB
  #
  # config.yamlerǖ=>`lCfbNX̘Azz
  # 擾B
  #
  # {'er1'=>0, 'er2'=>1 ... }
  #
  def initialize
    @szid_time = Time.now
    config = nil
    $LOAD_PATH.each do |dir|
      file = dir + '/' + CONFIG_FILE
      config = YAML.load_file(file) if File.exist?(file)
    end
    raise "#{CONFIG_FILE}܂B" unless config
    @hash_ch = config
  end

  #=== ScheInfo֕ϊ
  #
  #_iepg_:: iEPGIuWFNg
  #
  #_return_:: ScheInfoIuWFNg
  #
  def to_scheinfo(iepg)
    scheinfo = {}
    scheinfo[:szID] = szid
    scheinfo[:iSrcType] = 0
    scheinfo[:iChnIndex] = chnindex(iepg)
    scheinfo[:szPrgmTitle] = iepg.program_title
    scheinfo[:szPrgmSynopsis] = iepg.program_synopsis
    scheinfo[:iStartDateTime] = starttime(iepg)
    scheinfo[:iFreqFlag] = 0
    scheinfo[:lIntendedDurMin] = intended_durmin(iepg)
    scheinfo[:lActualDurMin] = 0
    scheinfo[:bHiddenRecord] = 'False'
    scheinfo[:iPowerShutType] = 0
    scheinfo[:iStatusFlag] = 0
    return ScheInfo.new(scheinfo)
  end

private

  #=== iEPGA`lCfbNXԋp
  #
  # Azz񂩂猩Ȃꍇ́A0ԂB
  #
  def chnindex(iepg)
    res = @hash_ch[iepg.station]
    raise "ǖ܂B#{CONFIG_FILE}Őݒ肵ĂB" if res.nil?
    raise "`lsłBŎw肵ĂB" unless res.is_a?(Integer)
    return res
  end

  #=== iEPGA^JnԂԋp
  #
  #_return_:: 'y:m:d:h:m:0'
  #
  def starttime(iepg)
    unless iepg.start =~ REGEXP_HOUR_MINUTES
      raise "tH[}bgsłB[iepg.start=#{iepg.start}]"
    end
    return format('%d:%d:%d:%d:%d:0', iepg.year.to_i, iepg.month.to_i,
                  iepg.date.to_i, $1.to_i, $2.to_i)
  end

  #=== iEPGA^掞Ԃԋp
  #
  # IJnȌꍇ́A
  # I̓̎ƂďB
  #
  #_return_:: ^掞()
  #
  def intended_durmin(iepg)
    unless iepg.start =~ REGEXP_HOUR_MINUTES
      raise "tH[}bgsłB[iepg.start=#{iepg.start}]"
    end
    start_t = Time.local(iepg.year, iepg.month, iepg.date, $1, $2)
    unless iepg.end =~ REGEXP_HOUR_MINUTES
      raise "tH[}bgsłB[iepg.end=#{iepg.end}]"
    end
    end_t = Time.local(iepg.year, iepg.month, iepg.date, $1, $2)
    if (end_t - start_t) > 0
       return (end_t - start_t).to_i / 60
    end
    end_t += 60 * 60 * 24
    return (end_t - start_t).to_i / 60
  end

  #=== \ID𐶐Aԋp
  #
  # ݂̎A\ID쐬ԋpB
  # IDƂĈӂɂ邽߁AĂяoxɎ + 1bi߂B
  #
  #_return_:: 'YYYYMMSS_HHMMSS'
  #
  def szid
    @szid_time += 1
    return @szid_time.strftime('%Y%m%d_%H%M%S')
  end

end
